diff --git a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
index 66adcb25e..2c8de1243 100644
--- a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.entity.player;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.data.registry.Registries;
@@ -188,10 +188,10 @@ public class MultiplayerLocalPlayer extends LocalPlayer
     }
 
     @Override
-	public void displayGUIGuidebook()
+	public void displayGuidebookScreen()
     {
-        mc.displayGuiScreen(new GuiGuidebook());
-        sendQueue.addToSendQueue(new GuidebookPacket(mc.currentScreen instanceof GuiGuidebook));
+        mc.displayScreen(new GuidebookScreen());
+        sendQueue.addToSendQueue(new GuidebookPacket(mc.currentScreen instanceof GuidebookScreen));
     }
 
     @Override
@@ -248,11 +248,11 @@ public class MultiplayerLocalPlayer extends LocalPlayer
     }
     
     @Override
-	public int getStat(Stat statbase)
+	public int getStat(Stat stat)
     {
-    	if (statbase.clientside)
+    	if (stat.clientside)
     	{
-    		return super.getStat(statbase);
+    		return super.getStat(stat);
     	}
     	return 0;
     }
diff --git a/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java b/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
index 8d599b232..4e08e4566 100644
--- a/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
@@ -14,6 +14,8 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.GetSkinUrlThread;
 
+import java.util.UUID;
+
 public class RemotePlayer extends Player
 {
     private int lerpSteps;
@@ -23,11 +25,12 @@ public class RemotePlayer extends Player
     private double lerpYRot;
     private double lerpXRot;
 //    float fallTime;
-    public RemotePlayer(World world, String username)
+    public RemotePlayer(World world, String username, UUID uuid)
     {
         super(world);
 //        fallTime = 0.0F;
         this.username = username;
+        this.uuid = uuid;
         heightOffset = 0.0F;
         footSize = 0.0F;
         noPhysics = true;
@@ -143,7 +146,7 @@ public class RemotePlayer extends Player
     }
 
     @Override
-	public void func_6420_o()
+	public void animate4()
     {
     }
 	@Override
diff --git a/src/main/java/net/minecraft/client/gui/GuiAddServer.java b/src/main/java/net/minecraft/client/gui/AddServerScreen.java
similarity index 58%
rename from src/main/java/net/minecraft/client/gui/GuiAddServer.java
rename to src/main/java/net/minecraft/client/gui/AddServerScreen.java
index 672eb2d4a..51e8773a7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiAddServer.java
+++ b/src/main/java/net/minecraft/client/gui/AddServerScreen.java
@@ -5,23 +5,21 @@ import net.minecraft.core.net.SavedServerList;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 
-import java.time.LocalDateTime;
-
 // Referenced classes of package net.minecraft.src:
 //            GuiScreen, GuiTextField, StringTranslate, GuiButton, 
 //            gGameSettings, GuiConnecting
 
-public class GuiAddServer extends GuiScreen
+public class AddServerScreen extends Screen
 {
-    private GuiButton buttonSave;
-    private GuiButton buttonCancel;
-    private GuiButton buttonShowIp;
-    private GuiTextField ipTextField;
-    private GuiTextField serverNameTextField;
+    private ButtonElement buttonSave;
+    private ButtonElement buttonCancel;
+    private ButtonElement buttonShowIp;
+    private TextFieldElement ipTextField;
+    private TextFieldElement serverNameTextField;
     private SavedServerList serverList;
     private boolean showIp = true;
 
-    public GuiAddServer(GuiScreen guiscreen, SavedServerList serverList)
+    public AddServerScreen(Screen guiscreen, SavedServerList serverList)
     {
         super(guiscreen);
         this.serverList = serverList;
@@ -39,15 +37,15 @@ public class GuiAddServer extends GuiScreen
     {
         I18n stringtranslate = I18n.getInstance();
         Keyboard.enableRepeatEvents(true);
-        controlList.clear();
-        controlList.add(buttonSave = new GuiButton(0, width / 2 - 100, height / 4 + 96 + 12, stringtranslate.translateKey("gui.add_server.button.save")));
-        controlList.add(buttonCancel = new GuiButton(1, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.add_server.button.cancel")));
-        serverNameTextField = new GuiTextField(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 18, 200, 20, "", "");
+        buttons.clear();
+        buttons.add(buttonSave = new ButtonElement(0, width / 2 - 100, height / 4 + 96 + 12, stringtranslate.translateKey("gui.add_server.button.save")));
+        buttons.add(buttonCancel = new ButtonElement(1, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.add_server.button.cancel")));
+        serverNameTextField = new TextFieldElement(this, font, width / 2 - 100, (height / 4 - 10) + 18, 200, 20, "", "");
         serverNameTextField.isFocused = true;
         serverNameTextField.setMaxStringLength(32);
-        ipTextField = new GuiTextField(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, "", "");
+        ipTextField = new TextFieldElement(this, font, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, "", "");
         ipTextField.setMaxStringLength(128);
-        controlList.add(buttonShowIp = new GuiButton(2, width / 2 - 100, (height / 4 - 10) + 50 + 18 + 20 + 4, 200, 20, getShowIpLabel()));
+        buttons.add(buttonShowIp = new ButtonElement(2, width / 2 - 100, (height / 4 - 10) + 50 + 18 + 20 + 4, 200, 20, getShowIpLabel()));
         buttonSave.enabled = false;
     }
 
@@ -57,13 +55,13 @@ public class GuiAddServer extends GuiScreen
     }
 
     @Override
-	public void onClosed()
+	public void removed()
     {
         Keyboard.enableRepeatEvents(false);
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(!button.enabled)
         {
@@ -71,7 +69,7 @@ public class GuiAddServer extends GuiScreen
         }
         if(button.id == 1)
         {
-            mc.displayGuiScreen(parentScreen);
+            mc.displayScreen(parentScreen);
         }
         else if(button.id == 0)
         {
@@ -83,7 +81,7 @@ public class GuiAddServer extends GuiScreen
             serverList.servers.add(new ServerData(serverName, ipText, showIp));
             serverList.writeToFile();
 
-            mc.displayGuiScreen(parentScreen);
+            mc.displayScreen(parentScreen);
         }
         else if (button.id == 2)
         {
@@ -93,10 +91,10 @@ public class GuiAddServer extends GuiScreen
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if(i != Keyboard.KEY_BACK) super.keyTyped(c, i, mouseX, mouseY);
-        if (i == Keyboard.KEY_TAB)
+        if(eventKey != Keyboard.KEY_BACK) super.keyPressed(eventCharacter, eventKey, mx, my);
+        if (eventKey == Keyboard.KEY_TAB)
         {
             if (!ipTextField.isFocused && !serverNameTextField.isFocused)
             {
@@ -109,43 +107,43 @@ public class GuiAddServer extends GuiScreen
             }
             return;
         }
-        if (i == Keyboard.KEY_RETURN)
+        if (eventKey == Keyboard.KEY_RETURN)
         {
             if (buttonSave.enabled)
             {
-                buttonPressed(buttonSave);
+                buttonClicked(buttonSave);
             }
         }
         if (ipTextField.isFocused)
         {
-            ipTextField.textboxKeyTyped(c, i);
+            ipTextField.textboxKeyTyped(eventCharacter, eventKey);
         }
         if (serverNameTextField.isFocused)
         {
-            serverNameTextField.textboxKeyTyped(c, i);
+            serverNameTextField.textboxKeyTyped(eventCharacter, eventKey);
         }
 
         buttonSave.enabled = ipTextField.getText().length() > 0;
     }
 
     @Override
-	public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+	public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
-        ipTextField.mouseClicked(mouseX, mouseY, mouseButton);
-        serverNameTextField.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
+        ipTextField.mouseClicked(mx, my, buttonNum);
+        serverNameTextField.mouseClicked(mx, my, buttonNum);
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
         I18n stringtranslate = I18n.getInstance();
-        drawDefaultBackground();
-        drawStringCentered(fontRenderer, stringtranslate.translateKey("gui.add_server.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
-        drawString(fontRenderer, stringtranslate.translateKey("gui.add_server.label.server_name"), serverNameTextField.xPosition, serverNameTextField.yPosition - 14, 0xa0a0a0);
-        drawString(fontRenderer, stringtranslate.translateKey("gui.add_server.label.ip_address"), ipTextField.xPosition, ipTextField.yPosition - 14, 0xa0a0a0);
+        renderBackground();
+        drawStringCentered(font, stringtranslate.translateKey("gui.add_server.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawString(font, stringtranslate.translateKey("gui.add_server.label.server_name"), serverNameTextField.xPosition, serverNameTextField.yPosition - 14, 0xa0a0a0);
+        drawString(font, stringtranslate.translateKey("gui.add_server.label.ip_address"), ipTextField.xPosition, ipTextField.yPosition - 14, 0xa0a0a0);
         ipTextField.drawTextBox();
         serverNameTextField.drawTextBox();
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/BadJavaArchScreen.java b/src/main/java/net/minecraft/client/gui/BadJavaArchScreen.java
new file mode 100644
index 000000000..e58f226f4
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/BadJavaArchScreen.java
@@ -0,0 +1,72 @@
+package net.minecraft.client.gui;
+
+// Referenced classes of package net.minecraft.src:
+//            GuiScreen, GuiButton, GuiMainMenu
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.lang.I18n;
+import org.slf4j.Logger;
+
+import java.awt.*;
+import java.net.URI;
+
+public class BadJavaArchScreen extends Screen
+{
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    public BadJavaArchScreen()
+    {
+    }
+
+    @Override
+	public void init()
+    {
+        I18n i = I18n.getInstance();
+        buttons.clear();
+        String downloadString = i.translateKey("gui.bad_java_arch.button.download");
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.bad_java_arch.button.continue")));
+        buttons.add(new ClickableLabelElement(1, width / 2 - 170 - font.getStringWidth(downloadString) / 2, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA));
+    }
+
+    @Override
+	protected void buttonClicked(ButtonElement button)
+    {
+        if(!button.enabled)
+        {
+            return;
+        }
+        if(button.id == 0)
+        {
+            mc.displayScreen(new MainMenuScreen());
+        }
+        Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
+        if (desktop != null && desktop.isSupported(Desktop.Action.BROWSE))
+        {
+            if (button.id == 1)
+            {
+                try
+                {
+                    desktop.browse(URI.create("https://adoptium.net/en-GB/temurin/releases/?version=8"));
+                }
+                catch (Exception e)
+                {
+                    LOGGER.error("Exception occurred when attempting to open URL 'https://adoptium.net/en-GB/temurin/releases/?version=8'!", e);
+                }
+            }
+        }
+    }
+
+    @Override
+	public void render(int xm, int ym, float partialTick)
+    {
+        I18n i = I18n.getInstance();
+        renderBackground();
+        drawStringCentered(font, i.translateKey("gui.bad_java_arch.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawString(font, i.translateKey("gui.bad_java_arch.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xa0a0a0);
+        drawString(font, i.translateKey("gui.bad_java_arch.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
+        drawString(font, i.translateKey("gui.bad_java_arch.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
+        drawString(font, i.translateKey("gui.bad_java_arch.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
+        super.render(xm, ym, partialTick);
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/gui/BlankScreen.java b/src/main/java/net/minecraft/client/gui/BlankScreen.java
new file mode 100644
index 000000000..ba5337189
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/BlankScreen.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.gui;
+
+public class BlankScreen extends Screen
+{
+    @Override
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
+    {
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/GuiButton.java b/src/main/java/net/minecraft/client/gui/ButtonElement.java
similarity index 86%
rename from src/main/java/net/minecraft/client/gui/GuiButton.java
rename to src/main/java/net/minecraft/client/gui/ButtonElement.java
index 971d65a90..0230f3e2c 100644
--- a/src/main/java/net/minecraft/client/gui/GuiButton.java
+++ b/src/main/java/net/minecraft/client/gui/ButtonElement.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
@@ -11,7 +11,7 @@ import net.minecraft.core.util.helper.Listener;
 // Referenced classes of package net.minecraft.src:
 //            Gui, RenderEngine
 
-public class GuiButton extends Gui implements GuiElement
+public class ButtonElement extends Gui implements GuiElement
 {
     public static final int STATE_DISABLED = 0;
     public static final int STATE_DEFAULT = 1;
@@ -29,14 +29,14 @@ public class GuiButton extends Gui implements GuiElement
     public boolean enabled;
     public boolean visible;
     public boolean playSound = true;
-    public Listener<GuiButton> listener;
+    public Listener<ButtonElement> listener;
 
-    public GuiButton(int id, int xPosition, int yPosition, String text)
+    public ButtonElement(int id, int xPosition, int yPosition, String text)
     {
         this(id, xPosition, yPosition, 200, 20, text);
     }
 
-    public GuiButton(int id, int xPosition, int yPosition, int width, int height, String text)
+    public ButtonElement(int id, int xPosition, int yPosition, int width, int height, String text)
     {
         enabled = true;
         visible = true;
@@ -48,7 +48,7 @@ public class GuiButton extends Gui implements GuiElement
         displayString = text;
     }
 
-    public GuiButton setTextures(String defaultTexture, String hoveredTexture, String disabledTexture) {
+    public ButtonElement setTextures(String defaultTexture, String hoveredTexture, String disabledTexture) {
         this.defaultTexture = TextureRegistry.getTexture(defaultTexture);
         this.hoveredTexture = TextureRegistry.getTexture(hoveredTexture);
         this.disabledTexture = TextureRegistry.getTexture(disabledTexture);
@@ -73,7 +73,7 @@ public class GuiButton extends Gui implements GuiElement
     {
         if (!visible) return;
 
-        FontRenderer fontrenderer = mc.fontRenderer;
+        Font font = mc.font;
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
 
@@ -106,7 +106,7 @@ public class GuiButton extends Gui implements GuiElement
                 textColor = 0xFFFFA0;
                 break;
         }
-        drawStringCentered(fontrenderer, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+        drawStringCentered(font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
     }
 
     public boolean isHovered(int mouseX, int mouseY)
@@ -127,7 +127,7 @@ public class GuiButton extends Gui implements GuiElement
         return enabled && mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
     }
     
-    public GuiButton setListener(Listener<GuiButton> listener) {
+    public ButtonElement setListener(Listener<ButtonElement> listener) {
     	this.listener = listener;
     	return this;
     }
diff --git a/src/main/java/net/minecraft/client/gui/GuiChatEmotePicker.java b/src/main/java/net/minecraft/client/gui/ChatEmotePickerElement.java
similarity index 92%
rename from src/main/java/net/minecraft/client/gui/GuiChatEmotePicker.java
rename to src/main/java/net/minecraft/client/gui/ChatEmotePickerElement.java
index cfa9db3b0..69cecf1cc 100644
--- a/src/main/java/net/minecraft/client/gui/GuiChatEmotePicker.java
+++ b/src/main/java/net/minecraft/client/gui/ChatEmotePickerElement.java
@@ -7,13 +7,12 @@ import net.minecraft.core.net.ChatEmotes;
 
 import java.util.Map;
 
-public class GuiChatEmotePicker
-    extends Gui {
+public class ChatEmotePickerElement extends Gui {
     private static final int CELL_WIDTH = 16;
     private static final int CELL_HEIGHT = 16;
 
     private final Minecraft mc;
-    private final GuiChat parent;
+    private final ChatScreen parent;
 
     private final int width;
     private final int height;
@@ -26,7 +25,7 @@ public class GuiChatEmotePicker
 
     private int scroll = 0;
 
-    public GuiChatEmotePicker(Minecraft mc, GuiChat parent, int xCells, int yCells) {
+    public ChatEmotePickerElement(Minecraft mc, ChatScreen parent, int xCells, int yCells) {
         this.mc = mc;
         this.parent = parent;
 
@@ -125,6 +124,6 @@ public class GuiChatEmotePicker
             color = 0xffffffa0;
         }
 
-        drawStringCentered(mc.fontRenderer, String.valueOf(c), x + CELL_WIDTH / 2, y + (CELL_HEIGHT / 2 - 4), color);
+        drawStringCentered(mc.font, String.valueOf(c), x + CELL_WIDTH / 2, y + (CELL_HEIGHT / 2 - 4), color);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiChat.java b/src/main/java/net/minecraft/client/gui/ChatScreen.java
similarity index 63%
rename from src/main/java/net/minecraft/client/gui/GuiChat.java
rename to src/main/java/net/minecraft/client/gui/ChatScreen.java
index 5a17db6d0..51462267d 100644
--- a/src/main/java/net/minecraft/client/gui/GuiChat.java
+++ b/src/main/java/net/minecraft/client/gui/ChatScreen.java
@@ -8,21 +8,21 @@ import org.lwjgl.input.Keyboard;
 import net.minecraft.client.gui.text.ITextField;
 import org.lwjgl.input.Mouse;
 
-public class GuiChat extends GuiScreen implements ITextField {
+public class ChatScreen extends Screen implements ITextField {
 
 	protected String message;
 	private int currentIndex = 0;
 	private String originalMessage;
 	private int updateCounter;
 	private final TextFieldEditor editor;
-	protected GuiChatEmotePicker emotePicker;
+	protected ChatEmotePickerElement emotePicker;
 	protected boolean showEmotePicker = false;
 
-	public GuiChat() {
+	public ChatScreen() {
 		this("");
 	}
 
-	public GuiChat(String initialMessage) {
+	public ChatScreen(String initialMessage) {
 		message = initialMessage;
 		updateCounter = 0;
 		editor = new TextFieldEditor(this);
@@ -33,14 +33,14 @@ public class GuiChat extends GuiScreen implements ITextField {
 	public void init() {
 		Keyboard.enableRepeatEvents(true);
 		int emotePickerYCells = (int)MathHelper.clamp(Math.ceil(ChatEmotes.getEmotes().size() / 5.0), 0, 4);
-		emotePicker = new GuiChatEmotePicker(mc, this, 5, emotePickerYCells);
+		emotePicker = new ChatEmotePickerElement(mc, this, 5, emotePickerYCells);
 		showEmotePicker = false;
 	}
 
 	@Override
-	public void onClosed() {
+	public void removed() {
 		Keyboard.enableRepeatEvents(false);
-		mc.ingameGUI.chatScroll = 0;
+		mc.ingameHud.chatScroll = 0;
 	}
 
 	@Override
@@ -53,14 +53,14 @@ public class GuiChat extends GuiScreen implements ITextField {
 			if (showEmotePicker) {
 				emotePicker.scrollOffset((int)(-dWheel / 0.1f));
 			} else {
-				mc.ingameGUI.chatScroll += dWheel / 1;
+				mc.ingameHud.chatScroll += dWheel / 1;
 			}
 		}
 	}
 
 	@Override
-	public void keyTyped(char c, int key, int mouseX, int mouseY) {
-		if (key == Keyboard.KEY_UP && mc.thePlayer.messageHistory.size() > 0) {
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+		if (eventKey == Keyboard.KEY_UP && mc.thePlayer.messageHistory.size() > 0) {
 			if (currentIndex == 0)
 			{
 				originalMessage = getText();
@@ -74,7 +74,7 @@ public class GuiChat extends GuiScreen implements ITextField {
 			editor.setCursor(10000);
 			return;
 		}
-		if (key == Keyboard.KEY_DOWN && currentIndex > 0)
+		if (eventKey == Keyboard.KEY_DOWN && currentIndex > 0)
 		{
 			if (currentIndex-1 == 0)
 			{
@@ -92,67 +92,67 @@ public class GuiChat extends GuiScreen implements ITextField {
 			editor.setCursor(10000);
 			return;
 		}
-		if (key == Keyboard.KEY_ESCAPE && !(this instanceof GuiSleepMP)) {
-			mc.displayGuiScreen(null);
+		if (eventKey == Keyboard.KEY_ESCAPE && !(this instanceof SleepScreenMP)) {
+			mc.displayScreen(null);
 			return;
 		}
-		if (key == Keyboard.KEY_RETURN) {
+		if (eventKey == Keyboard.KEY_RETURN) {
 			String s = message.trim();
 			if (s.length() > 0) {
 				String s1 = message.trim();
 				mc.thePlayer.sendChatMessage(s1);
 			}
-			mc.displayGuiScreen(null);
+			mc.displayScreen(null);
 			return;
 		}
-		editor.handleInput(key, c);
+		editor.handleInput(eventKey, eventCharacter);
 	}
 
 	@Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick) {
+	public void render(int xm, int ym, float partialTick) {
 		// Draw emote picker button
 		int emotePickerButtonColor = 0x80000000;
 		int emotePickerTextColor = 0xE0E0E0;
-		if (mouseX >= 2 && mouseX < 14 && mouseY >= height - 14 && mouseY < height - 2)
+		if (xm >= 2 && xm < 14 && ym >= height - 14 && ym < height - 2)
 		{
 			emotePickerButtonColor = 0x80ffffff;
 			emotePickerTextColor = 0xffffffa0;
 		}
 		drawRect(2, height - 14, 14, height - 2, emotePickerButtonColor);
-		drawStringCentered(fontRenderer, Character.toString('\u263a'), 2 + 6, height - 12, emotePickerTextColor);
+		drawStringCentered(font, Character.toString('\u263a'), 2 + 6, height - 12, emotePickerTextColor);
 
 		drawRect(16, height - 14, width - 2, height - 2, 0x80000000);
 
 		boolean drawCursor = (updateCounter / 6) % 2 == 0;
 		int cursor = editor.getCursor();
-		drawString(fontRenderer, message, 18, height - 12, 0xE0E0E0);
+		drawString(font, message, 18, height - 12, 0xE0E0E0);
 		if (drawCursor)
 		{
-			int width = fontRenderer.getStringWidth(message);
+			int width = font.getStringWidth(message);
 			if (cursor < message.length())
 			{
-				width = fontRenderer.getStringWidth(message.substring(0, cursor));
+				width = font.getStringWidth(message.substring(0, cursor));
 			}
-			drawString(fontRenderer, "_", 18 + width, height - 12, 0xE0E0E0);
+			drawString(font, "_", 18 + width, height - 12, 0xE0E0E0);
 		}
 
 		if (showEmotePicker) {
-			emotePicker.draw(2, height - 16 - emotePicker.getHeight(), mouseX, mouseY);
+			emotePicker.draw(2, height - 16 - emotePicker.getHeight(), xm, ym);
 		}
 
-		super.drawScreen(mouseX, mouseY, partialTick);
+		super.render(xm, ym, partialTick);
 	}
 
 	@Override
-	public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
-		super.mouseClicked(mouseX, mouseY, mouseButton);
-		if (mouseButton == 0) {
-			if (mouseX >= 2 && mouseX < 14 && mouseY >= height - 14 && mouseY < height - 2) {
+	public void mouseClicked(int mx, int my, int buttonNum) {
+		super.mouseClicked(mx, my, buttonNum);
+		if (buttonNum == 0) {
+			if (mx >= 2 && mx < 14 && my >= height - 14 && my < height - 2) {
 				showEmotePicker = !showEmotePicker;
 				return;
 			}
 			if (showEmotePicker) {
-				Character c = emotePicker.click(mouseX - 2, mouseY - (height - 16 - emotePicker.getHeight()));
+				Character c = emotePicker.click(mx - 2, my - (height - 16 - emotePicker.getHeight()));
 				if (c != null) {
 					editor.handleInput(0, c);
 					if (!Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) && !Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) showEmotePicker = false;
diff --git a/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java b/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
new file mode 100644
index 000000000..d634da271
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
@@ -0,0 +1,71 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.Font;
+import org.lwjgl.opengl.GL11;
+
+public class ClickableLabelElement extends ButtonElement
+{
+    private int textColor;
+    private int bgColor;
+    private boolean shadow = true;
+
+    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor, int bgColor)
+    {
+        super(id, xPosition, yPosition, s);
+        this.textColor = textColor;
+        this.bgColor = bgColor;
+        height = 12;
+        width = 0;
+    }
+
+    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor)
+    {
+        this(id, xPosition, yPosition, s, textColor, 0x7F000000);
+    }
+
+    public int getTextColor() {
+        return textColor;
+    }
+
+    public void setTextColor(int textColor) {
+        this.textColor = textColor;
+    }
+
+    public int getBgColor() {
+        return bgColor;
+    }
+
+    public void setBgColor(int bgColor) {
+        this.bgColor = bgColor;
+    }
+
+    public boolean isShadow() {
+        return shadow;
+    }
+
+    public void setShadow(boolean shadow) {
+        this.shadow = shadow;
+    }
+
+    @Override
+    public void drawButton(Minecraft mc, int mouseX, int mouseY)
+    {
+        if(!visible)
+        {
+            return;
+        }
+        Font font = mc.font;
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        boolean hovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+        width = font.getStringWidth(displayString) + 4;
+        drawRect(xPosition, yPosition, xPosition + width, yPosition + height, enabled ? (hovered ? 0x7F8080C0 : bgColor) : 0x00000000);
+        if (enabled && (shadow || hovered)) {
+            font.drawStringWithShadow(displayString, xPosition + 2, yPosition + 2, hovered ? 0xFFFFA0 : textColor);
+        } else {
+            font.drawString(displayString, xPosition + 2, yPosition + 2, 0x7F7F7F);
+        }
+        mouseDragged(mc, mouseX, mouseY);
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/gui/ConflictWarningScreen.java b/src/main/java/net/minecraft/client/gui/ConflictWarningScreen.java
new file mode 100644
index 000000000..016739dda
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/ConflictWarningScreen.java
@@ -0,0 +1,47 @@
+package net.minecraft.client.gui;
+
+// Referenced classes of package net.minecraft.src:
+//            GuiScreen, GuiButton, GuiMainMenu
+
+import net.minecraft.core.lang.I18n;
+
+public class ConflictWarningScreen extends Screen
+{
+
+    public ConflictWarningScreen()
+    {
+    }
+
+    @Override
+	public void init()
+    {
+        buttons.clear();
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, I18n.getInstance().translateKey("gui.conflict_warning.button.back")));
+    }
+
+    @Override
+	protected void buttonClicked(ButtonElement button)
+    {
+        if(!button.enabled)
+        {
+            return;
+        }
+        if(button.id == 0)
+        {
+            mc.displayScreen(new MainMenuScreen());
+        }
+    }
+
+    @Override
+	public void render(int xm, int ym, float partialTick)
+    {
+        I18n i = I18n.getInstance();
+        renderBackground();
+        drawStringCentered(font, i.translateKey("gui.conflict_warning.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawString(font, i.translateKey("gui.conflict_warning.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xa0a0a0);
+        drawString(font, i.translateKey("gui.conflict_warning.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
+        drawString(font, i.translateKey("gui.conflict_warning.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
+        drawString(font, i.translateKey("gui.conflict_warning.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
+        super.render(xm, ym, partialTick);
+    }
+}
